{$M 65000,0,655360}
Program WakARat;

Uses
    Crt, RMem, VESA, FHandler, Mouse, Vocs, Lib, Video2, Detect;

Type
    CutTyp = Record
       x1,y1,x2,y2: Integer;
    End;

    PosiTyp = Record
       x,y: Integer;
    End;

    RatteTyp = Record
               FrameCount, AktPic: Word;
               AnnoyCount: Word;
               Action: Word;
               Ratte: Byte;
    End;

    WaffeTyp = Record
               FrameCount, Pic: Word;
               _Inc: Integer;
               Da: Boolean;
               Feld: Integer;
               Nummer: Array[0..8] Of Record x,y: Integer; End;
    End;

    SenseTyp = Record
               FrameCount, Pic: Word;
               Da: Boolean;
               Anzahl:Longint;
    End;

    OptionsTyp = Record
               SB_Volume: Byte;
               GameSpeed, RatProbability: Word;
               MinKills: Longint;
    End;

Const
    GFXDir = 'GRAPHICS\';
    SFXDir = 'SOUNDS\';
    MOVIEDir = 'MOVIE\';
    MinKillForHarvest = 3;
    OptFile = 'wakarat.cfg';
    MulFaktor = 512;
    CodeSense: String = 'BJKFA';
    Konv = 128;
    XMS = 5500;
    MaxRatteGFX = 29;
    MaxRatten = 2;
    MaxBlutStufen = 6;
    ActionNix = 0;
    ActionHoch = 1;
    ActionAergern = 2;
    ActionRunter = 3;
    ActionAbkratzen = 4;
    ActionKoepfen = 5;
    StatRunning = 0;
    StatWon = 1;
    StatLost = 2;
    Loecher: Array[0..8] Of Record x,y:Integer End = (
              (x:12; y:-35),
              (x:-40; y:-20),
              (x:54; y:-16),
              (x:-94; y:-5),
              (x:2; y:-1),
              (x:94; y:2),
              (x:-52; y:14),
              (x:40; y:18),
              (x:-12; y:32));
    MaxMenu = 5;
    MenuLineSpace = 7;
    MenuFore = 225;
    MenuBack = 75;
    MenuData: Array[0..MaxMenu] Of Record
                                         Txt: String[64];
                                         Schieber: Boolean;
                                         Links, Rechts: String[32];
                                         StartY, EndY, ActScal, NextScal: Integer;
                                   End =
             (
              (Txt:'START'; Schieber:False),
              (Txt:'GESCHWINDIGKEIT'; Schieber:True; Links:'LANGSAM'; Rechts:'SCHNELL'),
              (Txt:'ANZAHL RATTEN'; Schieber:True; Links:'WENIGE'; Rechts:'VIELE'),
              (Txt:'MIN.PLATTHAUEN'; Schieber:True; Links:'50%'; Rechts:'90%'),
              (Txt:'SOUNDEFFEKTE'; Schieber:True; Links:'LEISE'; Rechts:'LAUT'),
              (Txt:'BEENDEN'; Schieber:False)
             );

Var
    SBOk: Boolean;
    ScrSeg: Word;
    SaveText: Record
       ScrX, ScrY: Word;
       Buffer: Array[0..3999] Of Byte;
    End;
    Opt: OptionsTyp;
    OptionsCounter:Integer;
    SpielEnde: Boolean;
    EchtZeit, GesamtZeit, Zeit, ZeitProzent: Longint;
    Matschen: Boolean;
    Sin_Ofs, Cos_Ofs: Word;
    SinFix:Array[-360..360] of Longint;
    CosFix:Array[-360..360] of Longint;
    AddSP: Word;
    Poppen: Boolean;
    Code:String;
    GameData: Record
              Points: Longint;
              KillRatio, Killed, RatCounter: Longint;
              TmpCount: Longint;
    End;
    KistenCounter,KistenPic: Word;
    Waffe_FrameCount: Word;
    x,y,Butt: Word;
    i,a: Integer;
    Incfac: Integer;
    Col: Byte;
    Ch: Char;
    Dummy: Longint;
    Kiste: Array[0..3] Of VESA_Sprite;
    RatteGFX: Array[0..MaxRatten] Of Array[0..MaxRatteGFX] Of VESA_Sprite;
    Ratten: Array[0..8] Of RatteTyp;
    Haemmerchen: Array[0..1] Of VESA_Sprite;
    Waffe: Array[0..0] Of Record Pic: Array[0..4] Of VESA_Sprite; End;
    Waf: WaffeTyp;
    Gitter:Array[0..8] Of Record
          x1,y1,x2,y2:Integer;
    End;
    Blut: Array[0..MaxBlutStufen-1] Of VESA_Sprite;
    BlutStufe: Array[0..8] Of Integer;
    BlutPosi: Array[0..8] Of Record x,y:Integer End;
    RattePosi: Array[0..MaxRatten] Of Array[0..MaxRatteGFX] Of PosiTyp;
    Sense: Array[0..9] Of VESA_Sprite;
    Sen: SenseTyp;
    Sfx: Array[0..29] Of Voc_Type;
    Options: Array[0..29] Of VESA_Sprite;
    PalNew:Array[0..768] Of Byte;
    Zahlen: Array[0..10] Of VESA_Sprite;
    MenuSprites: Array[0..MaxMenu] Of VESA_Sprite;
    SenSym: VESA_Sprite;
    BigFont, NormalFont: Byte;
    ForceDetect, ForceNoSound: Boolean;

Function Stri(Zahl: Longint): String;
Var
   Tmp: String;
Begin
     Str(Zahl,Tmp);
     Stri:=Tmp;
End;

Procedure ClearKeyBuf;
Var
   Ch: Char;
Begin
     While Keypressed Do Ch:=ReadKey;
End;

Function Real2Fix(_Real: Real): Longint;
Begin
     Real2Fix:=Round(_Real * Mulfaktor);
End;

Function Fix2Real(_Fix: Longint): Real;
Begin
     Fix2Real:=_Fix / Mulfaktor;
End;

Function FixMul(a,b :Longint): Longint; Near; External;
Function FixDiv(a,b :Longint): Longint; Near; External;
{$L fixed}
Procedure DrawTurned(Angle: Longint; Zoom: Longint; Var Spr: VESA_Sprite; MoveX, MoveY, AddVc, AddVs: Longint); Far; External;
{$L turn.obj}

Function GetCentered(x1,x2,Width: Integer): Integer;
Begin
  GetCentered:=(x1+(((x2-x1)-Width) Div 2));
End;

Procedure MakeTable;
Var
   i: Integer;
Begin
     For i:=-360 To 360 Do Begin
         SinFix[i]:=Real2Fix(Sin((Pi/180)*i));
         CosFix[i]:=Real2Fix(Cos((Pi/180)*i));
     End;
End;

Procedure LoadSFX;
Var
   i: Integer;
Begin
     VOC_Error:=Voc_NoError;
     For i:=1 To 12 Do Begin
         Voc_Load(SFXDir+'aua'+Stri(i)+'.voc',Sfx[i-1]);
     End;
     Voc_Load(SFXDir+'senseman.voc',Sfx[12]);
     Voc_Load(SFXDir+'lache4.voc',Sfx[13]);
     Voc_Load(SFXDir+'lache2.voc',Sfx[14]);
     Voc_Load(SFXDir+'lache3.voc',Sfx[15]);
     Voc_Load(SFXDir+'bok.voc',Sfx[16]);
     Voc_Load(SFXDir+'annoy1.voc',Sfx[17]);
     Voc_Load(SFXDir+'annoy2.voc',Sfx[18]);
     Voc_Load(SFXDir+'annoy3.voc',Sfx[19]);
     Voc_Load(SFXDir+'muella.voc',Sfx[20]);
     If VOC_Error <> VOC_NoError Then Begin
        WriteLn('Fehler beim Laden der Soundeffekte!');
        RMem_Done;
        Halt;
     End;
End;

Procedure LoadOptions;
Var
   f: File Of OptionsTyp;
   Dummy: Integer;
Begin
     Assign(f,OptFile);
     Dummy:=IOResult;
     {$I-}
     Reset(f);
     Read(f,Opt);
     If IOResult <> 0 Then With Opt Do Begin
        SB_Volume:=63;
        GameSpeed:=70;
        RatProbability:=4;
        MinKills:=75;
        WriteLn('   Konfigurationsdatei nicht gefunden. Verwende Standardeinstellungen.');
     End;
     Close(f);
     {$I+}
     Dummy:=IOResult;
End;

Procedure SaveOptions;
Var
   f: File Of OptionsTyp;
   Dummy: Integer;
Begin
     WriteLn('Schreibe '+OptFile+'...');
     Assign(f,OptFile);
     Dummy:=IOResult;
     {$I-}
     ReWrite(f);
     Write(f,Opt);
     Close(f);
     {$I+}
     If IOResult = 0 Then
        WriteLn('   '+Optfile+' erfolgreich gesichert.')
     Else
        WriteLn('   Konnte '+OptFile+' nicht sichern. Schreibfehler.');
End;

Procedure Leaveprogram;
Begin
     RMem_Done;
     VESA_Done;
     With SaveText Do Begin
          Asm
             pusha
             push  es
             mov   ax,ScrSeg
             mov   es,ax
             mov   ax,0
             mov   di,ax
             mov   ax,OFFSET SaveText.Buffer
             mov   si,ax
             mov   cx,2000
             rep   movsw
             pop   es
             popa
          End;
          GoToXY(ScrX, ScrY);
     End;
     SaveOptions;
     WriteLn('Wak A Rat erfolgreich beendet.');
     WriteLn;
     WriteLn('*****************************************************************************');
     WriteLn('BJ-Studios sind:');
     WriteLn('   Benjamin Bockmhl - Grafik, Programmierung');
     WriteLn('   Jan Strter - Programmierung, Grafik');
     WriteLn('*****************************************************************************');
     WriteLn;
     WriteLn('Fr Anregung, Kritik, Hinweise auf Fehler, Jobangebote (Ha, ha! Ok, war ein');
     WriteLn('schlechter Witz...), ect. schreibt an:');
     WriteLn('   Jan Strter, Freiheitstr.69, 42277 Wuppertal');
     WriteLn;
     WriteLn('Ach ja, noch etwas: Wak A Rat ist FREEWARE! Wir sind jedem dankbar, der das');
     WriteLn('Spiel weitergibt (unverndert natrlich)!');
     WriteLn;
     WriteLn('Danke!');
End;

Procedure LoadGFX;
Var
   i:Integer;
   f: File Of CutTyp;
   Tmp:VESA_Sprite;
   Data: CutTyp;
   m: Integer;

Procedure LoadLib(TheLib: String; Var TheArray: Array Of VESA_Sprite);
Var
   AnzPic: Word;
   Result: Boolean;
   Laenge, Start: Longint;
Begin
     If Pos('.',TheLib)=0 Then TheLib:=TheLib+'.lib';
     Result:=Lib_Init(TheLib);
     If (Not Result) Then Begin
        WriteLn('Fehler beim Laden von '+TheLib+'!');
        WriteLn(VESA_ErrStr(VESA_Err));
        RMem_Done;
        Halt;
     End;
     AnzPic:=Lib_GetFiles;
     Result:=Lib_GetFileInfo(0,'',Start,Laenge);
     i:=0;
     While (Result = True) Do Begin
           VESA_LoadBJFSprite(TheLib,TheArray[i],Start,Laenge);
           If (VESA_Error <> 0) Then Begin
              RMem_Done;
              WriteLn('Fehler beim Laden von '+TheLib+'!');
              WriteLn(VESA_ErrStr(VESA_Err));
              Halt;
           End;
           Inc(i);
           Result:=Lib_GetFileInfo(i,'',Start,Laenge);
     End;
End;

Procedure LoadDat(TheDat: String; Var TheArray: Array Of PosiTyp; Counter: Integer);
Var
   i: Integer;
   f: File Of CutTyp;
   Dummy: Integer;
Begin
     {$I-}
     If Pos('.',TheDat)=0 Then TheDat:=TheDat+'.dat';
     Dummy:=IOResult;
     Assign(f,TheDat);
     Reset(f);
     For i:=0 To Counter-1 Do Begin
         Read(f,Data);
         TheArray[i].x:=Data.x1;
         TheArray[i].y:=Data.y1;
     End;
     Close(f);
     If IOResult <> 0 Then Begin
        WriteLn('Fehler beim Laden von '+TheDat+'!');
        RMem_Done;
        Halt;
     End;
     {$I+}
End;

Begin
     { Libs laden... }
     LoadLib(GFXDir+'option.lib',Options[0]);
     LoadLib(GFXDir+'wack.lib',Kiste[0]);
     LoadLib(GFXDir+'ratte.lib',RatteGFX[0][0]);
     LoadLib(GFXDir+'ratte2.lib',RatteGFX[1][0]);
     LoadLib(GFXDir+'ratte3.lib',RatteGFX[2][0]);
     LoadLib(GFXDir+'koepfen.lib',RatteGFX[2][20]);
     LoadLib(GFXDir+'koepfen2.lib',RatteGFX[0][20]);
     LoadLib(GFXDir+'hammer',Waffe[0].Pic);
     LoadLib(GFXDir+'sense',Sense);
     LoadLib(GFXDir+'zahlen',Zahlen);
     LoadLib(GFXDir+'blut',Blut);

     { Einzelbilder laden... }
     VESA_LoadBJFSprite(GFXDir+'ham10000.bjf',Haemmerchen[0],0,0);
     VESA_LoadBJFSprite(GFXDir+'ham20000.bjf',Haemmerchen[1],0,0);
     VESA_LoadBJFsprite(GFXDir+'sense.bjf',SenSym,0,0);

     { DAT-Dateien laden... }
     LoadDat(GFXDir+'ratte',RattePosi[0],MaxRatteGFX-10+1);
     LoadDat(GFXDir+'ratte2',RattePosi[1],MaxRatteGFX-10+1);
     LoadDat(GFXDir+'ratte3',RattePosi[2],MaxRatteGFX-10+1);
     LoadDat(GFXDir+'koepfen',RattePosi[2][20],MaxRatteGFX-20+1);
     LoadDat(GFXDir+'koepfen2',RattePosi[0][20],MaxRatteGFX-20+1);
     For i:=20 To MaxRatteGFX Do Begin
         RatteGFX[1][i]:=RatteGFX[0][i];
         RattePosi[1][i]:=RattePosi[0][i];
     End;

     { Font laden und setzen... }
     BigFont:=VESA_Loadfont(GFXDir+'font1');
     NormalFont:=VESA_Loadfont(GFXDir+'versuch');
     VESA_SetFont(BigFont);

     { Prfen, ob irgendwelche Fehler, wenn ja --> abbrechen }
     If VESA_Error <> VESA_NoError Then Begin
        WriteLn('Fehler beim Lesen der Daten-Dateien!');
        RMem_Done;
        Halt;
     End;
End;

Procedure MakeMenuSprites;
Begin
     { Menupunkt-Sprites erstellen... }
     For i:=0 To MaxMenu Do Begin
         VESA_ClearBuf(0);
         VESA_OutTextXY(2,2,MenuData[i].Txt,MenuBack);
         VESA_OutTextXY(0,0,MenuData[i].Txt,MenuFore);
         VESA_GetSprite(0,0,VESA_TextWidth(MenuData[i].Txt)+2,VESA_TextHeight(MenuData[i].Txt)+2,MenuSprites[i]);
     End;
End;

Procedure SetPalette;
Begin
     { Palette setzen... }
     VESA_SetPal;
     VESA_MakeShadowPal(100,12,12);
     Col:=VESA_FindCol(64,64,64);
End;

Procedure ShowIntro;
Var
   Ch: Char;
Begin
     Ch:=#0;

     { Lachen abspielen... }
     Voc_Play(Sfx[14],0,64,4,False);

     { Intro-Video abspielen... }
     Timer_Begin_Count;
     Repeat Until TimerCounter >= 1000;
     vd2_ShowFirstFrame(MOVIEDir+'intro.vd2',Ptr($0a000,$0000),320,0,20);
     Timer_Begin_Count;
     While ((Not vd2_LastFrame) And (Ch <> #27)) Do Begin
           Repeat Until TimerCounter >= 60;
           Timer_Begin_Count;
           vd2_shownextframe;
           If keypressed Then Ch:=ReadKey;
     End;
     vd2_Close;
     VESA_ClearBuf(0);
     VESA_ShowBuf;
End;

Procedure SetNewPal; Assembler;
Asm
   push si
   mov si,Offset PalNew
   mov cx,256*3
   xor al,al
   mov dx,03c8h
   out dx,al
   inc dx

   rep outsb
   pop si
End;

Function FadeToRGB(r,g,b,Speed:Byte):Boolean;
{
 Zieht die ganze Palette auf die Angegebene RGB-Farbe.
}
Var
   i:Integer;
   Ok:Boolean;

Begin
     Ok:=True;
     For i:=0 To 255 Do Begin
         If PalNew[i*3]<>r Then Begin
            Ok:=false;
            Break;
         End;
         If PalNew[i*3+1]<>g Then Begin
            Ok:=false;
            Break;
         End;
         If PalNew[i*3+2]<>b Then Begin
            Ok:=false;
            Break;
         End;
     End;
     FadeToRGB:=Ok;
     If Ok=True Then Exit;
     Asm
        mov  ax,ds
        mov  es,ax
        lea  si,PalNew
        mov  cx,256
        xor  dh,dh
        mov  dl,speed
     @Loop:
        lodsb
        mov  bl,r
        cmp  al,bl
        je   @g
        ja   @DecR
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @g
     @DecR:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @g:
        lodsb
        mov  bl,g
        cmp  al,bl
        je   @b
        ja   @DecG
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @b
     @DecG:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @b:
        lodsb
        mov  bl,b
        cmp  al,bl
        je   @Weiter
        ja   @DecB
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @Weiter
     @DecB:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @Weiter:
        dec  dl
        Cmp  dl,0
        je   @SpeedWeiter
        sub  si,3
        jmp  @Loop
     @SpeedWeiter:
        mov  dl,Speed
        dec  cx
        cmp  cx,0
        je   @Ende
        jmp  @Loop
     @Ende:
        Call SetNewpal
     End;
End;

Function FadeToPal(Speed:Byte):Boolean;
Var
   i:Integer;
   Ok:Boolean;
Begin
     Ok:=True;
     For i:=0 To 255 Do Begin
         If PalNew[i*3]<>VESA_Palette[i*3] Then Begin
            Ok:=false;
            Break;
         End;
         If PalNew[i*3+1]<>VESA_Palette[i*3+1] Then Begin
            Ok:=false;
            Break;
         End;
         If PalNew[i*3+2]<>VESA_Palette[i*3+2] Then Begin
            Ok:=false;
            Break;
         End;
     End;
     FadeToPal:=Ok;
     If Ok=True Then Exit;
     Asm
        mov  ax,ds
        mov  es,ax
        lea  si,PalNew
        lea  di,VESA_Palette
        mov  cx,256
        xor  dh,dh
        mov  dl,speed
     @Loop:
        push si
        mov  si,di
        lodsb      {al --> Palette}
        mov  di,si
        pop  si
        mov  bl,al {bl --> Palette}

        lodsb {al --> PalNew}

        cmp  al,bl
        je   @g
        ja   @DecR
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @g
     @DecR:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @g:
        push si
        mov  si,di
        lodsb      {al --> Palette}
        mov  di,si
        pop  si
        mov  bl,al {bl --> Palette}

        lodsb {al --> PalNew}

        cmp  al,bl
        je   @b
        ja   @DecG
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @b
     @DecG:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @b:
        push si
        mov  si,di
        lodsb      {al --> Palette}
        mov  di,si
        pop  si
        mov  bl,al {bl --> Palette}

        lodsb {al --> PalNew}

        cmp  al,bl
        je   @Weiter
        ja   @DecB
        inc  al
        dec  si
        mov  ds:[si],al
        lodsb
        jmp  @Weiter
     @DecB:
        dec  al
        dec  si
        mov  ds:[si],al
        lodsb
     @Weiter:
        dec  dl
        Cmp  dl,0
        je   @SpeedWeiter
        sub  si,3
        sub  di,3
        jmp  @Loop
     @SpeedWeiter:
        mov  dl,Speed
        dec  cx
        cmp  cx,0
        je   @Ende
        jmp  @Loop
     @Ende:
        Call SetNewpal
     End;
End;

Procedure InitGitter;
Var
   i:Integer;
Begin
     Gitter[0].x1:=142;
     Gitter[0].y1:=99;
     Gitter[0].x2:=192;
     Gitter[0].y2:=117;

     Gitter[1].x1:=91;
     Gitter[1].y1:=113;
     Gitter[1].x2:=141;
     Gitter[1].y2:=132;

     Gitter[2].x1:=181;
     Gitter[2].y1:=118;
     Gitter[2].x2:=231;
     Gitter[2].y2:=136;

     Gitter[3].x1:=41;
     Gitter[3].y1:=128;
     Gitter[3].x2:=90;
     Gitter[3].y2:=146;

     Gitter[4].x1:=131;
     Gitter[4].y1:=133;
     Gitter[4].x2:=180;
     Gitter[4].y2:=150;

     Gitter[5].x1:=221;
     Gitter[5].y1:=137;
     Gitter[5].x2:=270;
     Gitter[5].y2:=155;

     Gitter[6].x1:=80;
     Gitter[6].y1:=147;
     Gitter[6].x2:=130;
     Gitter[6].y2:=165;

     Gitter[7].x1:=170;
     Gitter[7].y1:=151;
     Gitter[7].x2:=220;
     Gitter[7].y2:=170;

     Gitter[8].x1:=119;
     Gitter[8].y1:=166;
     Gitter[8].x2:=169;
     Gitter[8].y2:=184;

     With Waf Do Begin
          Nummer[0].x:=148;
          Nummer[0].y:=101;

          Nummer[1].x:=96;
          Nummer[1].y:=115;

          Nummer[2].x:=190;
          Nummer[2].y:=119;

          Nummer[3].x:=48;
          Nummer[3].y:=129;

          Nummer[4].x:=142;
          Nummer[4].y:=134;

          Nummer[5].x:=230;
          Nummer[5].y:=136;

          Nummer[6].x:=88;
          Nummer[6].y:=148;

          Nummer[7].x:=180;
          Nummer[7].y:=151;

          Nummer[8].x:=126;
          Nummer[8].y:=166;
     End;
     For i:=0 To 8 Do BlutStufe[i]:=0;

     BlutPosi[0].x:=142;
     BlutPosi[0].y:=92;
     BlutPosi[1].x:=89;
     BlutPosi[1].y:=107;
     BlutPosi[2].x:=183;
     BlutPosi[2].y:=111;
     BlutPosi[3].x:=35;
     BlutPosi[3].y:=122;
     BlutPosi[4].x:=131;
     BlutPosi[4].y:=126;
     BlutPosi[5].x:=225;
     BlutPosi[5].y:=130;
     BlutPosi[6].x:=77;
     BlutPosi[6].y:=141;
     BlutPosi[7].x:=172;
     BlutPosi[7].y:=145;
     BlutPosi[8].x:=119;
     BlutPosi[8].y:=160;
End;

Procedure CheckForMem;
Var
   Memory: Longint;
Begin
     Memory:=Longint(Konv)*Longint(1024);
     If MaxAvail < Memory Then Begin
        WriteLn('Nicht gengend konventioneller Speicher.');
        WriteLn('Es fehlen ',Konv-(MaxAvail Div 1024)+1,' KB Speicher.');
        WriteLn('Entfernen Sie berflssige TSR-Programme aus den Startdateien.');
        Halt;
     End;
End;

Function  UCase(Str: String): String; Assembler;
Asm
   push  es
   push  ds
   les   di,@Result           { Ziel nach ES:DI laden }
   lds   si,Str               { Quelle nach DS:SI laden }
   mov   cl,ds:[si]           { String-Lnge nach CL laden }
   xor   ch,ch
   inc   si
   mov   es:[di],cl           { Und sofort in Ziel-String kopieren }
   or    cl,cl
   je    @TheEnd
   inc   di
@Loop:
   mov   al,ds:[si]           { Buchstabe lesen }
   cmp   al,97                { Prfen, ob er zwischen 'a' und 'z' liegt }
   jb    @NoConvert
   cmp   al,122
   ja    @NoConvert
   sub   al,32                { 32 abziehen, um Grobuchstaben zu erhalten }
   jmp   @LoopEnd
@NoConvert:
   cmp   al,148               { '' ? }
   jne   @NoOe
   mov   al,153               { In '' konvertieren }
   jmp   @LoopEnd
@NoOe:
   cmp   al,129               { '' ? }
   jne   @NoUe
   mov   al,154               { In '' konvertieren }
   jmp   @LoopEnd
@NoUe:
   cmp   al,132               { '' ? }
   jne   @LoopEnd
   mov   al,142               { In '' konvertieren }
@LoopEnd:
   mov   es:[di],al           { Konvertierten Buchstaben in Ziel-String schreiben }
   inc   di
   inc   si
   dec   cl
   jne   @Loop                { Bis alles abgearbeitet ist }
@TheEnd:
   pop   ds
   pop   es
End;

Procedure HandleParameters;
Var
   i: Integer;
Begin
     ForceDetect:=False;
     ForceNosound:=False;
     If ParamCount > 0 Then Begin
        For i:=1 To ParamCount Do Begin
            If UCase(ParamStr(i)) = 'DETECT' Then ForceDetect:=True
            Else If UCase(ParamStr(i)) = 'NOSOUND' Then ForceNoSound:=True
            Else If UCase(ParamStr(i)) = 'HELP' Then Begin
                 WriteLn;
                 WriteLn('Parameter:  Funktion:');
                 WriteLn('-----------------------------------------------------------------------------');
                 WriteLn('   detect - Soundkarte hardwareseitig erkennen, SET BLASTER nicht');
                 WriteLn('            verwenden');
                 WriteLn('  nosound - Soundkarte nicht verwenden (falls der Rechner beim Start abstrtzt,');
                 WriteLn('            diese Option versuchen)');
                 WriteLn('     help - Diesen Hilfetext anzeigen');
                 RMem_Done;
                 Halt;
            End;
        End;
     End;
End;

Procedure FindSB;
Var
   Adr: Word;
   Irq, Dma: Byte;
   AdrStr: String;
   Result: Boolean;
Begin
     SBOk:=False;
     If ForceNoSound Then Begin
        WriteLn('   NOSOUND-Parameter gesetzt. Soundkarte wird nicht verwendet.');
        Exit;
     End;
     If (Not ForceDetect) Then
        Result:=Detect_Environ(Adr, Irq, Dma, AdrStr)
     Else
        WriteLn('   DETECT-Parameter gesetzt. BLASTER-Umgebungsvariable wird nicht ausgewertet.');
     If (Result And (Not ForceDetect)) Then Begin
        WriteLn('   SET BLASTER Eintrag gefunden.');
        WriteLn('   Port:'+AdrStr+', IRQ:',Irq,', DMA:',Dma);
        WriteLn('   Versuche, Soundblaster zu initialisieren...');
        If VOC_Init(Adr, Irq, Dma) Then Begin
           WriteLn('   Erfolgreich!');
           SBOk:=True;
        End Else Begin
           WriteLn('   Fehlgeschlagen!');
           SBOk:=False;
        End;
     End;
     If (Not Result) And (Not ForceDetect) Then
        WriteLn('   BLASTER-Umgebungsvariable nicht gesetzt oder fehlerhaft.');
     If (Not SBOk) Then Begin
        WriteLn('   Versuche, SoundBlaster hardwareseitig zu erkennen...');
        WriteLn('   (Achtung: Der DMA-Kanal kann nicht ber Hardware erkannt werden.');
        WriteLn('    Es wird angenommen, da der DMA-Kanal 1 ist.)');
        If Detect_Hardware(Adr, Irq, AdrStr) Then Begin
           Dma:=1;
           WriteLn('   SoundBlaster gefunden.');
           WriteLn('   Port:'+AdrStr+', IRQ:',Irq,', DMA:',Dma);
           WriteLn('   Versuche, Soundblaster zu initialisieren...');
           If VOC_Init(Adr, Irq, Dma) Then Begin
              WriteLn('   Erfolgreich!');
              SBOk:=True;
           End Else Begin
              WriteLn('   Fehlgeschlagen!');
              SBOk:=False;
           End;
        End Else Begin
           WriteLn('   Es wurde keine SoundBlaster gefunden.');
        End;
     End;
End;

Procedure ColorCheck;
Begin
     If (Mem[$0000:$0410] And $30) <> $30 Then ScrSeg:=$B800 Else ScrSeg:=$B000;
End;

Procedure InitProgram;
Begin

     { Status-Titelzeile anzeigen }
     ClrScr;
     TextColor(White);
     TextBackGround(Red);
     WriteLn('                               Wak A Rat v1.2                                  ');
     WriteLn('                     (c) Copyright 1997-1998 BJ-Studios                        ');
     TextColor(LightGray);
     TextBackGround(Black);

     { Parameter abhandlen }
     HandleParameters;

     { Prfen, ob genug konv. Speicher }
     CheckForMem;

     { Flat-Mode initialisieren }
     WriteLn('Initialisiere Flat-Mode...');
     RMem_Init(XMS);

     { Einstellungen laden... }
     WriteLn('Lade '+OptFile+'...');
     LoadOptions;

     { Soundkarten-Einstellungen herausfinden }
     WriteLn('Suche SoundBlaster-Karte...');
     FindSB;

     { Sounds laden... }
     If SBOk Then Begin
        Voc_Set_Volume(Opt.SB_Volume);
        Voc_Set_Sample_Rate(Byte(256 - Longint(1000000 Div 22000)));
        WriteLn('Lade Soundeffekte...');
        LoadSFX;
     End;

     { Grafiken laden... }
     WriteLn('Lade Grafiken...');
     If MaxAvail < $FFFF Then Begin
        WriteLn('Nicht gengend Konventioneller Speicher.');
        RMem_Done;
        Halt;
     End Else Begin
        GetMem(VESA_Buffer,$FFFF);
        VESA_Error:=VESA_NoError;
        LoadGFX;
        FreeMem(VESA_Buffer,$FFFF);
     End;

     WriteLn('Starte Wak A Rat...');

     { Textbildschirm sichern. (Vllig berflssig, aber irgendwie cool...) }
     ColorCheck;
     With SaveText Do Begin
          ScrX:=WhereX;
          ScrY:=WhereY;
          Asm
             pusha
             push  ds
             push  es
             mov   ax,ds
             mov   es,ax
             mov   ax,ScrSeg
             mov   ds,ax
             mov   ax,0
             mov   si,ax
             mov   ax,OFFSET SaveText.Buffer
             mov   di,ax
             mov   cx,2000
             rep   movsw
             pop   es
             pop   ds
             popa
          End;
     End;

     { VGA-Modus einschalten...}
     VESA_Init(VESA_320x200);
     If VESA_Error <> VESA_NoError Then Begin
        WriteLn(VESA_ErrStr(VESA_Err));
        RMem_Done;
        Halt;
     End;
     MakeMenuSprites;

     { Mouse initialisieren... }
     InitMouse;
     If MouseErr Then Begin
        RMem_Done;
        VESA_Done;
        WriteLn('Um Wak A Rat spielen zu knnen, wird eine Microsoft-Kompatible Maus bentigt!');
        Halt;
     End;
     SetLimits(0,VESA_MaxX,0,VESA_MaxY);

     { Palette setzen und Intro-Video abspielen }
     SetPalette;
     ShowIntro;

     { Variablen initialisieren... }
     For a:=0 To 8 Do With Ratten[a] Do Begin
         FrameCount:=0;
         AktPic:=0;
         AnnoyCount:=0;
         Action:=ActionNix;
         Ratte:=0;
     End;
     Randomize;
     Code:='';
     InitGitter;
     With GameData Do Begin
          Points:=0;
          KillRatio:=0;
          Killed:=0;
          RatCounter:=0;
     End;
     KistenCounter:=0;
     KistenPic:=0;
     For i:=0 To 768 Do PalNew[i]:=VESA_Palette[i];
     EchtZeit:=30;
     GesamtZeit:=30*EchtZeit;
     Matschen:=False;
     Poppen:=True;
     With Waf Do Begin
          FrameCount:=0;
          Da:=False;
          _Inc:=1;
          Pic:=0;
     End;
     With Sen Do Begin
          FrameCount:=0;
          Da:=False;
          Pic:=0;
          Anzahl:=0;
     End;
     IncFac:=1;
     MakeTable;
     Sin_Ofs := Ofs(SinFix);
     Cos_Ofs := Ofs(CosFix);
End;

Procedure MaleRatten;
Var
   i: Word;
   col: byte;
   offset: integer;
   offsetx: integer;
Begin
     offsetx := 1;
     offset := 2;
     col := 200;
     For i:=0 To 8 Do Begin
         If BlutStufe[i] > 0 Then With BlutPosi[i] Do
            VESA_PutSpriteExact(x,y,Blut[BlutStufe[i]-1]);
     End;
     { elipsen: new version!!}
     For i:= 0 To 8 Do With Gitter[i] Do Begin
         If ((x >= x1) And (x <= x2)) And ((y >= y1) And (y <= y2)) Then
         Begin
              VESA_Ellipse(BlutPosi[i].x+32,BlutPosi[i].y+15,offsetx+20,offset+8,col);
              VESA_Ellipse(BlutPosi[i].x+32,BlutPosi[i].y+15,offsetx+21,offset+8,col);
              VESA_Ellipse(BlutPosi[i].x+31,BlutPosi[i].y+15,offsetx+21,offset+8,col);
              VESA_Ellipse(BlutPosi[i].x+33,BlutPosi[i].y+15,offsetx+21,offset+8,col);
              VESA_Ellipse(BlutPosi[i].x+32,BlutPosi[i].y+15,offsetx+22,offset+9,col);
              VESA_Ellipse(BlutPosi[i].x+31,BlutPosi[i].y+15,offsetx+22,offset+9,col);
              VESA_Ellipse(BlutPosi[i].x+33,BlutPosi[i].y+15,offsetx+22,offset+9,col);
              VESA_Ellipse(BlutPosi[i].x+32,BlutPosi[i].y+15,offsetx+23,offset+10,col);
              Break;
         End;
     End;
     For i:=0 To 8 Do With Ratten[i] Do Begin
         If Action <> ActionNix Then VESA_PutSpriteExact(Loecher[i].x+RattePosi[Ratte][AktPic].x+1,
            Loecher[i].y+RattePosi[Ratte][AktPic].y+1,RatteGFX[Ratte][AktPic]);
     End;
End;

Procedure BewegeRatten;
Var
   i: Word;
Begin
     For i:=0 To 8 Do With Ratten[i] Do Begin
         Case Action Of
            ActionHoch:
              Begin
                   If FrameCount >= 1 Then Begin
                      Inc(AktPic);
                      FrameCount:=0;
                      If AktPic > 4 Then Action:=ActionAergern;
                   End Else Inc(FrameCount);
              End;
            ActionAergern:
              Begin
                   If FrameCount >= 0 Then Begin
                      Inc(AktPic);
                      FrameCount:=0;
                      If AktPic > 14 Then Begin
                         If AnnoyCount > 0 Then Begin
                            Dec(AnnoyCount);
                            AktPic:=5;
                         End Else Begin
                            Action:=ActionRunter;
                            AktPic:=4;
                         End;
                      End;
                   End Else Inc(FrameCount);
              End;
            ActionRunter:
              Begin
                   If FrameCount >= 1 Then Begin
                      FrameCount:=0;
                      Dec(AktPic);
                      If AktPic <= 0 Then Action:=ActionNix;
                   End Else Inc(FrameCount);
              End;
            ActionAbkratzen:
              Begin
                   If FrameCount >= 3 Then Begin
                      FrameCount:=0;
                      Inc(AktPic);
                      If AktPic >= 19 Then Action:=ActionNix;
                   End Else Inc(FrameCount);
              End;
            ActionKoepfen:
               Begin
                    If FrameCount >= 1 Then Begin
                       FrameCount:=0;
                       Inc(AktPic);
                       If AktPic >= 29 Then Action:=ActionNix;
                    End else Inc(FrameCount);
               End;
         End;
     End;
End;

Procedure NeueRatten;
Var
   i,m: Word;
Begin
     If Random(200) <= Opt.RatProbability Then Begin
        For i:=0 To 8 Do Begin
            m:=Random(9);
            If Ratten[m].Action = ActionNix Then With Ratten[m] Do Begin
               Action:=ActionHoch;
               AktPic:=0;
               FrameCount:=0;
               AnnoyCount:=Random(3)+1;
               Ratte:=Random(MaxRatten+1);
               If Ratte > MaxRatten Then Ratte:=MaxRatten;
               Inc(GameData.RatCounter);
               Voc_Play(Sfx[Random(4)+17],255,64,4,False);
               Exit;
            End;
        End;
     End;
End;

Procedure Koepfen(Nr: Word);
Begin
     If Nr > 8 Then Exit;
     With Ratten[Nr] Do Begin
          If ((Action <> ActionAbkratzen) And (Action <> ActionNix) And (Action <> ActionKoepfen)) Then Begin
             AktPic:=20;
             Action:=ActionKoepfen;
             Voc_Play(Sfx[Random(12)],0,64,4,False);
             FrameCount:=0;
             If BlutStufe[Nr] < MaxBlutStufen Then Inc(BlutStufe[Nr]);
             Inc(GameData.Points,10);
             Inc(GameData.Killed);
          End;
     End;
End;

Procedure HandleMouseEvent;
Var
   Pansophie: Integer;
Begin
     GetMousePosition(Butt,x,y);
     If (ButtonPressed(RightButton) And (Not Sen.Da)) And
        ((Sen.Anzahl > 0) Or (Sen.Anzahl=-1)) Then With Sen Do  Begin
        If Sen.Anzahl > 0 Then Dec(Sen.Anzahl);
        Da:=True;
        Pic:=0;
        Voc_Play(sfx[12],0,64,4,False);
     End Else If ButtonPressed(LeftButton) And ((Not Waf.Da) And (Not Sen.Da)) Then With Waf Do Begin
        Feld:=-1;
        For a:= 0 To 8 Do With Gitter[a] Do Begin
            If ((x >= x1) And (x <= x2)) And ((y >= y1) And (y <= y2)) Then
            Begin
                 Feld:=a;
                 Break;
            End;
        End;
        If Feld > -1 Then Begin
           Da:=True;
           Pic:=0;
           FrameCount:=0;
           _Inc:=1;
        End;
     End;
     If Waf.Da Then With Waf Do Begin
        VESA_PutSpriteExact(Nummer[Feld].x-160,Nummer[Feld].y-100,Waffe[0].Pic[Pic]);
        Inc(FrameCount);
        If FrameCount >= 1 Then Begin
           FrameCount:=0;
           Inc(Pic,_inc);
           If Pic >= 4 Then Begin
              If (Ratten[Feld].Action <> ActionNix) And (Ratten[Feld].Action <> ActionAbkratzen)
                 Then With Ratten[Feld] Do Begin
                 AktPic:=15;
                 Action:=ActionAbkratzen;
                 FrameCount:=0;
                 If BlutStufe[Feld] < MaxBlutStufen Then Inc(BlutStufe[Feld]);
                 Inc(GameData.Points,10);
                 Inc(GameData.Killed);
                 Inc(GameData.TmpCount);
                 Voc_Play(Sfx[Random(12)],10,64,4,False);
                 Voc_Play(Sfx[16],0,64,4,False);
              End Else Begin
                 Dec(GameData.Points,5);
                 Dec(GameData.Killed);
                 Voc_Play(Sfx[16],0,64,4,False);
              End;
              _Inc:=-1;
           End;
           If (_Inc = -1) And (Pic = 0) Then Da:=False;
        End;
     End Else If (Not Sen.Da) Then Begin
        Pansophie:=-1;
        For a:= 0 To 8 Do With Gitter[a] Do Begin
            If ((x >= x1) And (x <= x2)) And ((y >= y1) And (y <= y2)) Then
            Begin
                 Pansophie:=a;
                 Break;
            End;
        End;
{        If Pansophie > -1 Then VESA_PutSpriteExact(x-33,y-40,Haemmerchen[1]) Else}
           VESA_PutSpriteExact(x-33,y-40,Haemmerchen[1]);
     End;
     If Sen.Da Then With Sen Do Begin
        VESA_PutSpriteExact(0,0,Sense[Pic]);
        If FrameCount >= 1 Then Begin
           FrameCount:=0;
           Inc(Pic);
           If Pic >= 9 Then Begin
              Pic:=0;
              Da:=False;
           End Else Begin
              Case Pic Of
                   5: Begin
                           Koepfen(0);
                      End;
                   6: Begin
                           Koepfen(1);
                           Koepfen(2);
                      End;
                   7: Begin
                           Koepfen(3);
                           Koepfen(4);
                           Koepfen(5);
                           Koepfen(6);
                      End;
                   8: Begin
                           Koepfen(7);
                           Koepfen(8);
                      End;
              End;
           End;
        End Else Inc(FrameCount);
     End;
End;

Procedure MalePunkte;
Var
   i: Byte;
   ch: Char;
   s: String;
   StartX: Integer;
Begin
     Str(Abs(GameData.Killed),s);
     If GameData.Killed < 0 Then Begin
        VESA_PutSpriteExact(5,175,Zahlen[10]);
        StartX:=5+Zahlen[10].Width;
     End Else StartX:=5;
     For i:=0 To Length(s)-1 Do Begin
        VESA_PutSpriteExact(StartX,175,Zahlen[Ord(s[i+1])-48]);
        Inc(StartX,Zahlen[Ord(s[i+1])-48].Width);
     End;
End;

Procedure ZeigeStatistik(Typ: Byte);
Var
   Headline: String;
   Clicked: Boolean;
   Ch: Char;
   Ende: Boolean;
   Spruch: String;
   FrameCounter: Word;
Procedure Shadowed(y: Integer; Txt: String);
Begin
     VESA_OutTextXY(GetCentered(0,319,VESA_TextWidth(Txt))+1,y+1,Txt,0);
     VESA_OutTextXY(GetCentered(0,319,VESA_TextWidth(Txt)),y,Txt,Col);
End;
Begin
     Case Typ Of
          StatRunning: Headline:='PAUSE';
          StatWon: Headline:='GEWONNEN!';
          StatLost: Headline:='VERLOREN!';
     End;
     VESA_BarShadow(0,0,319,199);
     With GameData Do Begin
          If RatCounter > 0 Then KillRatio:=Killed*100 Div RatCounter Else KillRatio:=0;
          VESA_SetFont(BigFont);
          Shadowed(25,Headline);
          VESA_SetFont(NormalFont);
          Shadowed(70,'RATTEN INSGESAMT: '+Stri(RatCounter));
          Shadowed(90,'DAVON PLATTGEHAUEN: '+Stri(KillRatio)+'%');
          Shadowed(110,'BENTIGT: '+Stri(Opt.MinKills)+'%');
          Spruch:='';
          If Typ = StatRunning Then Begin
             If KillRatio <= 0 Then Spruch:='MEIN GOTT, BIST DU SCHLECHT!'
             Else If KillRatio >= Opt.MinKills Then Spruch:='VOLLER EHRE!'
             Else Spruch:='BUNG MACHT DEN MEISTER, NICHT WAHR?';
          End Else Begin
             If Typ = StatLost Then Begin
                If Abs(Opt.MinKills-KillRatio) <= 5 Then
                   Spruch:='SCHADE, WAS? DAS WAR KNAPP!'
                Else If (Abs(Opt.MinKills-KillRatio) >= 40) And (KillRatio > 0) Then
                   Spruch:='GIB LOOSERN KEINE CHANCE!'
                Else If KillRatio <= 0 Then
                   Spruch:='HOLY SHIT! DAS IST BEL!'
                Else
                   Spruch:='BEN! BEN! BEN!';
             End Else Begin
                Spruch:='MANN, BIST DU EIN HELD!';
                If KillRatio < 90 Then Begin
                   Shadowed(180,'VERSUCH DOCH MAL, 90% DER RATTEN ZU');
                   Shadowed(188,'TTEN. DANN GIBT ES EINE BERRASCHUNG!');
                End;
             End;
          End;
          Shadowed(145,Spruch);
     End;
     VESA_ShowBuf;
     Ende:=False;
     Clicked:=False;
     If Typ <> StatRunning Then Begin
        Timer_Begin_Count;
        Repeat
              If Keypressed Then Begin
                 Ch := Readkey;
                 If Ch = #0 Then Ch := ReadKey;
              End;
        Until TimerCounter >= 400;
     End;
     Repeat
           If ButtonPressed(LeftButton) Then Clicked:=True;
           If ButtonReleased(LeftButton) And Clicked Then Ende:=True;
           If Keypressed Then Begin
              Ende:=True;
              Ch := Readkey;
              If Ch = #0 Then Ch := ReadKey;
           End;
     Until Ende;
     If (Typ = StatWon) And (GameData.KillRatio >= 90) Then Begin
        Voc_Stop_All;
        For i:=0 To 768 Do PalNew[i]:=VESA_Palette[i];
        VESA_FadeOut;
        VESA_ClearBuf(0);
        VESA_ShowBuf;
        Timer_Begin_Count;
        Repeat Until TimerCounter >= 1000;
        vd2_ShowFirstFrame(MOVIEDir+'outro.vd2',Ptr($0a000,$0000),320,0,20);
        Timer_Begin_Count;
        FrameCounter:=0;
        Voc_Play(Sfx[15],0,64,0,True);
        While ((Not vd2_LastFrame) And (Ch <> #27)) Do Begin
              Repeat Until TimerCounter >= 100;
              Timer_Begin_Count;
              vd2_shownextframe;
              If keypressed Then Ch:=ReadKey;
              Inc(FrameCounter);
              If FrameCounter = 35 Then Begin
                 Voc_Play(Sfx[16],255,64,0,False);
                 Voc_Play(Sfx[1],0,64,4,False);
              End;
              If FrameCounter = 50 Then Voc_Play(Sfx[12],0,64,4,False);
              If FrameCounter = 57 Then Voc_Play(Sfx[5],0,64,4,False);
        End;
        vd2_Close;
        VESA_ClearBuf(0);
        VESA_ShowBuf;
        For i:=0 To 768 Do VESA_Palette[i]:=PalNew[i];
        VESA_SetPal;
        Voc_Stop_All;
     End;
End;

Procedure PlayDataLoop;
Var
   TimeCount: Longint;
   DelayCount: Integer;
   Abwarten: Boolean;
Begin
     ZeitProzent:=1000;
     Zeit:=GesamtZeit;
     SpielEnde:=False;
     Abwarten:=False;
     For a:=0 To 8 Do With Ratten[a] Do Begin
         FrameCount:=0;
         AktPic:=0;
         AnnoyCount:=0;
         Action:=ActionNix;
         Ratte:=0;
     End;
     For a:=0 To 8 Do Blutstufe[a]:=0;
     With GameData Do Begin
          Points:=0;
          KillRatio:=0;
          Killed:=0;
          RatCounter:=0;
     End;
     With Sen Do Begin
          Anzahl:=0;
          Da:=False;
     End;
     With Waf Do Begin
          FrameCount:=0;
          Da:=False;
          _Inc:=1;
          Pic:=0;
     End;
     ClearKeyBuf;

     Repeat
           Timer_Begin_Count;
           VESA_PutSpriteMedium(0,0,Kiste[KistenPic]);
           MaleRatten;
           BewegeRatten;
           If (Not Abwarten) Then NeueRatten;
           HandleMouseEvent;
           MalePunkte;
           Timer_Stop_Count;
           Repeat Until TimerCounter >= Opt.GameSpeed;

           Inc(TimeCount,TimerCounter);
           If TimeCount >= 1820 Then Begin
              TimeCount:=0;
              If GameData.TmpCount >= MinKillForHarvest Then Begin
                 Voc_Play(Sfx[15],255,64,4,False);
                 Inc(Sen.Anzahl);
              End;
              GameData.TmpCount:=0;
           End;
           If Sen.Anzahl > 0 Then Begin
              VESA_PutSpriteExact(256,160,SenSym);
              VESA_OutTextXY(255,185,Stri(Sen.Anzahl)+'x',Col);
           End;

           If (Not Abwarten) Then Begin
              If Zeit > 0 Then Dec(Zeit) Else Begin
                 Abwarten:=True;
                 DelayCount:=90;
              End;
           End;

           ZeitProzent:=Round(Zeit*1000/GesamtZeit);
           VESA_BarShadow(2,2,Round(ZeitProzent*0.316)+2,12);

           If Abwarten Then Begin
              If DelayCount > 0 Then Dec(DelayCount) Else SpielEnde:=True;
           End;

           FadeToPal(5);
           VESA_ShowBuf;

           Inc(KistenCounter);
           If KistenCounter > 2 Then Begin
              KistenCounter:=0;
              Inc(KistenPic);
              If KistenPic > 3 Then KistenPic:=0;
           End;

           If Keypressed Then Begin
              Ch := Readkey;
              If Ch = #0 Then Begin
                 Ch := Readkey;
              End Else begin
                  If Ch = ' ' Then ZeigeStatistik(StatRunning) Else Begin
                     Code:=Code+Upcase(ch);
                     If Code[Length(Code)] <> CodeSense[Length(Code)] Then
                        Code:=''
                     Else If Code=CodeSense Then Begin
                          Sen.Anzahl:=-1;
                          Code:='';
                     End;
                     ClearKeyBuf;
                  End;
              End;
           End;

     Until (Ch = #27) Or SpielEnde;
     If Ch <> #27 Then Begin
        ClearKeyBuf;
        With GameData Do Begin
             If RatCounter > 0 Then KillRatio:=Killed*100 Div RatCounter Else KillRatio:=0;
             If KillRatio >= Opt.MinKills Then
                ZeigeStatistik(StatWon)
             Else
                ZeigeStatistik(StatLost);
        End;
     End;
End;

Function PlayMenu: Boolean;
Var
    ActMenu: Integer;
    MenuAddY, Tmp:Integer;
    Zwischen: Real;
    Fps: Longint;
    Angle: Integer;
    Beenden, Spielen: Boolean;
    ScrollBar: Boolean;
    ScrollBarValue, OldValue: Integer;
    ScrollBarMax: Integer;
    ScrollBarUnit: Real;
    Clicked: Boolean;

Procedure MaleMaus;
Begin
     VESA_Line(x-11,y,x-2,y,Col);
     VESA_Line(x+2,y,x+11,y,Col);
     VESA_Line(x,y-10,x,y-2,Col);
     VESA_Line(x,y+2,x,y+10,Col);
End;

Procedure SetScrollBar(Value: Integer);
Begin
     ScrollBarValue:=Value;
     ScrollBarUnit:=290/ScrollBarMax;
     SetPointerPosition(Round(ScrollBarValue*ScrollBarUnit),y);
End;

Begin
     VESA_SetFont(NormalFont);
     Clicked:=False;
     ScrollBar:=False;
     ScrollBarValue:=0;
     ScrollBarMax:=0;
     MenuAddY:=200;
     For i:=0 To MaxMenu Do Begin
         Dec(MenuAddY,MenuSprites[i].Height);
         Dec(MenuAddY,MenuLineSpace);
     End;
     MenuAddY:=MenuAddY Div 2;
     Tmp:=MenuAddY;
     For i:=0 To MaxMenu Do With MenuData[i] Do Begin
         StartY:=Tmp;
         Inc(Tmp,MenuSprites[i].Height+MenuLineSpace);
         EndY:=Tmp-1;
         ActScal:=100;
         NextScal:=100;
     End;

     For i:=0 To 768 Do PalNew[i]:=VESA_Palette[i];
     Repeat
           VESA_WaitRetrace;
     Until FadeToRGB(0,0,0,5) = True;

     Tmp:=0;
     OptionsCounter:=0;
     Angle:=0;
     Ch := #0;
     ActMenu:=0;
     Spielen:=False;
     Beenden:=False;

     Repeat
           Timer_Begin_Count;
           FadeToPal(5);
           Asm
              mov ax,sp
              add ax,2
              mov dx,0
              mov bx,4
              div bx
              mov AddSP,dx
              add sp,dx
           End;
           DrawTurned(Angle,512,Options[OptionsCounter],-160,-100,2,-2);
           Asm
              mov ax,AddSP
              sub sp,ax
           End;
           GetMousePosition(Butt,x,y);

           If ScrollBar Then Begin

              For i:=0 To MaxMenu Do With MenuData[i] Do Begin
                  If (ActMenu = i) Then
                     VESA_PutSpriteScal(GetCentered(0,320,MenuSprites[i].Width*110 Div 100),
                                     GetCentered(StartY,EndY,MenuSprites[i].Height*110 Div 100),
                                     110,110,MenuSprites[i])
                  Else
                     VESA_PutSpriteScal(GetCentered(0,320,MenuSprites[i].Width*ActScal Div 100),
                                     GetCentered(StartY,EndY,MenuSprites[i].Height*ActScal Div 100),
                                     ActScal,ActScal,MenuSprites[i]);
              End;
              With MenuData[ActMenu] Do Tmp:=GetCentered(StartY,EndY,1);
              VESA_Line(5,Tmp,15,Tmp,MenuFore);
              VESA_Line(305,Tmp,315,Tmp,MenuFore);
              VESA_Line(5,Tmp,5,195,Menufore);
              VESA_Line(315,Tmp,315,195,MenuFore);
              VESA_Line(5,195,15,195,MenuFore);
              VESA_Line(305,195,315,195,MenuFore);
              VESA_RectAngle(15,190,305,199,MenuFore);
              VESA_OutTextXY(15,181,MenuData[ActMenu].Links,MenuFore);
              With MenuData[ActMenu] Do
                   VESA_OutTextXY(305-VESA_TextWidth(Rechts),181,Rechts,MenuFore);
              ScrollBarUnit:=290/ScrollBarMax;
              ScrollBarValue:=Round(x/ScrollBarUnit);
              If ScrollBarValue > ScrollBarMax Then ScrollBarValue:=ScrollBarMax;
              Tmp:=Round(ScrollBarValue*ScrollBarUnit)+15;
              VESA_BarRaster(16,191,Tmp,198,MenuFore);
              VESA_Line(Tmp,190,Tmp,199,Col);
              VESA_Line(Tmp-5,190,Tmp,190,Col);
              VESA_Line(Tmp-5,190,Tmp,199,Col);

              If ActMenu = 4 Then Begin
                 If OldValue <> ScrollBarValue Then Begin
                    OldValue:=ScrollBarValue;
                    Voc_Set_Volume(ScrollBarValue);
                    Voc_Play(Sfx[16],255,64,0,False);
                 End;
              End;

              If ButtonPressed(LeftButton) Then Clicked:=True;
              If ButtonPressed(RightButton) Then Begin
                 ScrollBar:=False;
                 Voc_Set_Volume(Opt.SB_Volume);
              End;
              If ButtonReleased(LeftButton) And Clicked Then Begin
                 Clicked:=False;
                 ScrollBar:=False;
                 Case ActMenu Of
                      1: Begin
                              Opt.GameSpeed:=Round(1820/(ScrollBarValue+25));
                         End;
                      2: Begin
                              Opt.RatProbability:=2+ScrollBarValue;
                         End;
                      3: Begin
                              Opt.MinKills:=50+(ScrollBarValue*5);
                         End;
                      4: Begin
                              Opt.SB_Volume:=ScrollBarValue;
                              Voc_Set_Volume(Opt.SB_Volume);
                         End;
                 End;
              End;
              If KeyPressed Then Begin
                 Ch := ReadKey;
                 If Ch = #0 Then Begin
                    Ch := ReadKey;
                 End Else Begin
                    Case Ch Of
                         #27: Begin
                                   ScrollBar:=False;
                                   Voc_Set_Volume(Opt.SB_Volume);
                              End;
                    End;
                 End;
              End;

           End Else Begin

              For i:=0 To MaxMenu Do With MenuData[i] Do Begin
                  If (ActMenu = i) Then
                     VESA_PutSpriteScal(GetCentered(0,320,MenuSprites[i].Width*110 Div 100),
                                     GetCentered(StartY,EndY,MenuSprites[i].Height*110 Div 100),
                                     110,110,MenuSprites[i])
                  Else
                     VESA_PutSpriteScal(GetCentered(0,320,MenuSprites[i].Width*ActScal Div 100),
                                     GetCentered(StartY,EndY,MenuSprites[i].Height*ActScal Div 100),
                                     ActScal,ActScal,MenuSprites[i]);
                  If ((y >= StartY) And (y <= EndY)) Then ActMenu:=i;
                  Tmp:=Abs(ActMenu-i);
                  NextScal:=100-Tmp*13;
                  If ActScal < NextScal Then Begin
                     Inc(ActScal,3);
                     If ActScal > NextScal Then ActScal:=NextScal;
                  End;
                  If ActScal > NextScal Then Begin
                     Dec(ActScal,3);
                     If ActScal < NextScal Then ActScal:=NextScal;
                  End;
              End;
              MaleMaus;
              If ButtonPressed(LeftButton) Then Clicked:=True;
              If ButtonReleased(LeftButton) And Clicked Then Begin
                 Clicked:=False;
                 Voc_Play(Sfx[16],0,64,4,False);
                 Case ActMenu Of
                      0: Spielen:=True;
                      1: Begin
                              ScrollBar:=True;
                              ScrollBarMax:=25;
                              SetScrollBar(Round(1/((Opt.GameSpeed)/1820))-25);
                         End;
                      2: Begin
                              ScrollBar:=True;
                              ScrollBarMax:=18;
                              SetScrollBar(Opt.RatProbability-2);
                         End;
                      3: Begin
                              ScrollBar:=True;
                              ScrollBarMax:=8;
                              SetScrollBar((Opt.MinKills-50) Div 5);
                         End;
                      4: Begin
                              ScrollBar:=True;
                              ScrollBarMax:=63;
                              SetScrollBar(Opt.SB_Volume);
                         End;
                      5: Beenden:=True;
                 End;
              End;
              If KeyPressed Then Begin
                 Ch := ReadKey;
                 If Ch = #0 Then Begin
                    Ch := ReadKey;
                 End Else Begin
                    Case Ch Of
                         #27: Begin
                                   Spielen:=False;
                                   Beenden:=True;
                              End;
                         #13: Begin
                                   Spielen:=True;
                                   Beenden:=False;
                              End;
                    End;
                 End;
              End;
           End;

           VESA_ShowBuf;
           Inc(OptionsCounter);
           If OptionsCounter=30 Then OptionsCounter:=0;
           Inc(Angle,2);
           If Angle > 360 Then Begin
              Angle := Angle - 360;
           End;
           Repeat Until TimerCounter >= 60;
     Until (Spielen Or Beenden);

     For i:=0 To 768 Do PalNew[i]:=VESA_Palette[i];
     Repeat
           VESA_Waitretrace;
     Until FadeToRGB(0,0,0,5) = True;
     If Spielen Then Matschen:=True Else Matschen:=False;
     If Beenden Then PlayMenu:=False Else PlayMenu:=True;
End;

Begin
     Timer_On;
     InitProgram;
     ClearKeyBuf;
     Repeat
           ClearKeyBuf;
           Ch := #0;
           Poppen:=PlayMenu;
           If (Poppen And Matschen) Then PlayDataLoop;
     Until Poppen = False;
     Timer_Off;
     LeaveProgram;
End.